failed 9p experiment
[distro-setup] / mount-latest-subvol
index 091cf44448d4cace3675056a015f179f9cfa2989..6bf68d703b7f90b3a2379ceeeca1335991afcfc6 100644 (file)
@@ -13,7 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-
+# usage: mount-latest-subvol
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
@@ -32,7 +32,7 @@ errcatch() {
     set -o pipefail
 }
 bash-trace() {
-    local -i argc_index=0 arg frame i start=${1:-1} max_indent=8 indent
+    local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
     local source
     local extdebug=false
     if [[ $(shopt -p extdebug) == *-s* ]]; then
@@ -76,6 +76,7 @@ mnt() {
 
 ret=0
 
+##### begin setup fstab for subvols we care about ######
 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
 tu /etc/fstab <<EOF
 $first_root_crypt  /a  btrfs  noatime,subvol=a  0 0
@@ -84,43 +85,51 @@ case $HOSTNAME in
     treetowl|x2|frodo)
         tu /etc/fstab <<EOF
 $first_root_crypt  /q  btrfs  noatime,subvol=q  0 0
+$first_root_crypt  /o  btrfs  noatime,subvol=o  0 0
 /q/p  /p  none  bind  0 0
+/o/m  /m  none  bind  0 0
 EOF
         ;;
 esac
+##### end setup fstab for subvols we care about ######
 
-for vol in q a; do
+for vol in q a o; do
     d=/$vol
     if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
         continue
     fi
 
 
-    binds=()
-    roots=($d)
+    ##### begin building up list of bind mounts  ######
+    binds=() # list of bind mounts
+    roots=($d) # list of bind mounts, plus the original mount
     while true; do
         new_roots=()
         for r in ${roots[@]}; do
-            # example
+            # eg. when r=/q/p, for lines like
             # /q/p  /p  none  bind  0 0
+            # output /p
             new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
         done
         (( ${#new_roots} )) || break
         binds+=(${new_roots[@]})
         roots=( ${new_roots[@]} )
     done
+    ##### end building up list of bind mounts  ######
+
 
     # if latest is already mounted, make sure binds are mounted and move on
     if e check-subvol-stale $d; then
+        mnt $d
         for b in ${binds[@]}; do
             mnt $b
         done
         continue
     fi
 
-    last_snap=$(</nocow/btrfs-stale/$vol)
-    if [[ ! $last_snap ]]; then
-        echo "$0: error. empty last_snap var"
+    fresh_snap=$(</nocow/btrfs-stale/$vol)
+    if [[ ! $fresh_snap ]]; then
+        echo "$0: error. empty fresh_snap var"
         ret=1
         continue
     fi
@@ -135,6 +144,7 @@ for vol in q a; do
                 umount_ret=false
                 ret=1
                 echo "$0: failed to umount $dir"
+                e lsof $dir
                 break
             fi
         fi
@@ -147,14 +157,15 @@ for vol in q a; do
         continue
     fi
 
+    # todo: decipher /mnt/root, like we do in check-subvol-stale
     cd /mnt/root
     if [[ -e $vol ]]; then
-        e btrfs sub del $vol
+        e mv $vol $vol.leaf.$(date +%Y%m%dT%H%M%S%z)
     fi
     # Note, we make a few assumptions in this script, like
     # $d was not a different subvol id than $vol, and
     # things otherwise didn't get mounted very strangely.
-    e btrfs sub snapshot btrbk/$last_snap $vol
+    e btrfs sub snapshot $fresh_snap $vol
     for dir in $d ${binds[@]}; do
         e mnt $dir
     done
@@ -162,7 +173,8 @@ for vol in q a; do
     rm -f $stale_dir/$d
 done
 
-if [[ $HOSTNAME == treetowl ]]; then
+### disabled
+if [[ $HOSTNAME == treetowlxxxxxxxxx ]]; then
     # partitioned it with fai partitioner outside of fai,
     # because it\'s worth it to have 1% space reserved for boot and
     # swap partitions in case I ever want to boot off those drives.